<?php
/**
* O擾
* @param $directory Oi[fBNg
* @param $year N
* @param $month 
* @param $day 
* @param $period 
* @return 擾O̔z
*/
function get_log($directory, $year, $month, $day, $period) {
	$log = array();

	// 
	if (strcmp($year, "") != 0 && strcmp($month, "") != 0 && strcmp($day, "") != 0) {
		for ($i = 0; $i < $period; $i++) {
			$file = $directory.date("Ymd", mktime(0, 0, 0, $month, $day, $year) + (60 * 60 * 24 * $i)).".log";
			if (file_exists($file)) $log = array_merge($log, unserialize(file_get_contents($file)));
		}
	// 
	} else if (strcmp($year, "") != 0 && strcmp($month, "") != 0) {
		for ($i = 1; $i <= 31; $i++) {
			$file = $directory.date("Ymd", mktime(0, 0, 0, $month, $i, $year)).".log";
			if (file_exists($file)) $log = array_merge($log, unserialize(file_get_contents($file)));
		}
	// N
	} else if (strcmp($year, "") != 0) {
		for ($i = 1; $i <= 12; $i++) {
			for ($j = 1; $j <= 31; $j++) {
				$file = $directory.date("Ymd", mktime(0, 0, 0, $i, $j, $year)).".log";
				if (file_exists($file)) $log = array_merge($log, unserialize(file_get_contents($file)));
			}
		}
	}

	foreach ($log as $key => $array) {
		$log[$key]["os"] = get_os_by_agent($array["agent"]);
		$log[$key]["browser"] = get_browser_by_agent($array["agent"]);
		$log[$key]["language_name"] = get_lang_by_accept($array["language"]);
		$log[$key]["referer_link"] = get_link_by_referer($array["referer"]);
		$log[$key]["search_engine"] = get_se_by_referer($array["referer"]);
		$log[$key]["search_query"] = get_sq_by_referer($array["referer"]);
	}

	return $log;
}

/**
* HTTP_REFERER烊N擾
* @param $agent HTTP_USER_AGENT
* @return N
*/
function get_link_by_referer($referer) {
	if (strcmp($referer, "") == 0) return "";
	return "<a href=\"".$referer."\" target=\"_blank\">".$referer."</a>";
}

/**
* HTTP_USER_AGENTOS擾
* @param $agent HTTP_USER_AGENT
* @return OS
*/
function get_os_by_agent($agent) {
	if (preg_match("/Windows.NT.6\.0/", $agent)) {
		return "Windows Vista";
	} else if (preg_match("/Windows.NT.5\.1/", $agent)) {
		return "Windows XP";
	} else if (preg_match("/Windows.NT.5\.0/", $agent)) {
		return "Windows 2000";
	} else if (preg_match("/Windows.98/", $agent)) {
		return "Windows 98";
	} else if (preg_match("/Windows.95/", $agent)) {
		return "Windows 95";

	} else if (preg_match("/mac/", $agent)) {
		return "Macintosh";
	} else if (preg_match("/linux/", $agent)) {
		return "Linux";

	} else {
		return "̑";
	}
}

/**
* HTTP_USER_AGENTuEU擾
* @param $agent HTTP_USER_AGENT
* @return uEU
*/
function get_browser_by_agent($agent) {
	if (preg_match("/MSIE.8\./", $agent)) {
		return "Internet Explorer 8";
	} else if (preg_match("/MSIE.7\./", $agent)) {
		return "Internet Explorer 7";
	} else if (preg_match("/MSIE.6\./", $agent)) {
		return "Internet Explorer 6";
	} else if (preg_match("/MSIE.5\.5/", $agent)) {
		return "Internet Explorer 5.5";
	} else if (preg_match("/MSIE.5\./", $agent)) {
		return "Internet Explorer 5";
	} else if (preg_match("/MSIE.4\./", $agent)) {
		return "Internet Explorer 4";

	} else if (preg_match("/Netscape.7\./", $agent)) {
		return "Netscape 7";
	} else if (preg_match("/Netscape6/", $agent)) {
		return "Netscape 6";

	} else if (preg_match("/Firefox.3\./", $agent)) {
		return "Firefox 3";
	} else if (preg_match("/Firefox.2\./", $agent)) {
		return "Firefox 2";
	} else if (preg_match("/Firefox.1\.5/", $agent)) {
		return "Firefox 1.5";
	} else if (preg_match("/Firefox.1\./", $agent)) {
		return "Firefox 1";
	} else if (preg_match("/Firefox.0\./", $agent)) {
		return "Firefox ";

	} else if (preg_match("/Opera.9\./", $agent)) {
		return "Opera 9";
	} else if (preg_match("/Opera.8\./", $agent)) {
		return "Opera 8";
	} else if (preg_match("/Opera.7\./", $agent)) {
		return "Opera 7";
	} else if (preg_match("/Opera.6\./", $agent)) {
		return "Opera 6";

	} else if (preg_match("/Safari.5[0-9][0-9]/", $agent) && preg_match("/Version.4\./", $agent)) {
		return "Safari 4";
	} else if (preg_match("/Safari.5[0-9][0-9]/", $agent)) {
		return "Safari 3";
	} else if (preg_match("/Safari.4[0-9][0-9]/", $agent)) {
		return "Safari 2";
	} else if (preg_match("/Safari/", $agent)) {
		return "Safari 1";

	} else if (preg_match("/Chrome/", $agent)) {
		return "Google Chrome";
	} else if (preg_match("/Konqueror/", $agent)) {
		return "Konqueror";
	} else if (preg_match("/Dreampassport/", $agent)) {
		return "Dreampassport";
	} else if (preg_match("/Sun/", $agent)) {
		return "Hot Java Browser";
	} else if (preg_match("/BTRON/", $agent)) {
		return "BTRON";
	} else if (preg_match("/iCab/", $agent)) {
		return "iCab";
	} else if (preg_match("/Lynx/", $agent)) {
		return "Lynx";
	} else if (preg_match("/Shiira/", $agent)) {
		return "VC";
	} else if (preg_match("/WebCapture/", $agent)) {
		return "Adobe Acrobat";

	} else if (preg_match("/Mozilla/", $agent)) {
		return "Mozilla";
	} else {
		return "̑";
	}
}

/**
* HTTP_REFERER猟GW擾
* @param $referer HTTP_REFERER
* @return GW
*/
function get_se_by_referer($referer) {
	if (preg_match("/google(\.com|\.co\.jp).*q=[^&]*/", $referer)) {
		return "Google";
	} else if (preg_match("/yahoo(\.com|\.co\.jp).*p=[^&]*/", $referer)) {
		return "Yahoo";
	} else if (preg_match("/excite(\.com|\.co\.jp).*search=[^&]*/", $referer)) {
		return "Excite";
	} else if (preg_match("/goo\.ne\.jp.*MT=[^&]*/", $referer)) {
		return "goo";
	} else if (preg_match("/infoseek(\.com|\.co\.jp).*qt=[^&]*/", $referer)) {
		return "Infoseek";
	} else if (preg_match("/msn(\.com|\.co\.jp).*q=[^&]*/", $referer)) {
		return "MSN";
	} else if (preg_match("/livedoor\.com.*q=[^&]*/", $referer)) {
		return "livedoor";
	} else if (preg_match("/nifty\.com.*q=[^&]*/", $referer)) {
		return "@nifty";
	} else if (preg_match("/fresheye\.com.*kw=[^&]*/", $referer)) {
		return "tbVAC";
	} else if (preg_match("/biglobe\.ne\.jp.*q=[^&]*/", $referer)) {
		return "BIGLOBE";
	} else {
		return "";
	}
}

/**
* HTTP_REFERER猟L[[h擾
* @param $referer HTTP_REFERER
* @return L[[h
*/
function get_sq_by_referer($referer) {
	if (strcmp(get_se_by_referer($referer), "") == 0) return "";
	$sq = preg_replace("/.*?(q|p|search|MT|qt|kw)=([^&]*).*/", "$2", $referer);
	$sq = urldecode($sq);
	$sq = mb_convert_encoding($sq, "SJIS", "auto");
	return $sq;
}

/**
* HTTP_ACCEPT_LANGUAGE猾擾
* @param $accept HTTP_ACCEPT_LANGUAGE
* @return 
*/
function get_lang_by_accept($accept) {
	$code = substr($accept, 0, 2);
	$code_list = array(
		"aa" => "At@iAfarj",
		"ab" => "AvnWAiAbkhazianj",
		"af" => "AtJ[XiAfrikaansj",
		"am" => "AniAmharicj",
		"ar" => "ArAiArabicj",
		"as" => "AbTiAssamesej",
		"ay" => "AC}iAymaraj",
		"az" => "A[oCWFiAzerbaijanij",
		"ba" => "oVL[iBashkirj",
		"be" => "VAiByelorussianj",
		"bg" => "uKAiBulgarianj",
		"bh" => "rn[iBiharij",
		"bi" => "rX}iBislamaj",
		"bn" => "xKiBengalij",
		"bo" => "`xbgiTibetanj",
		"br" => "u^[jiBretonj",
		"ca" => "J^iCatalanj",
		"co" => "RVJiCorsicanj",
		"cs" => "`FbNiCzechj",
		"cy" => "EF[YiWelshj",
		"da" => "f}[NiDanishj",
		"de" => "hCciGermanj",
		"dz" => "u[^iBhutanij",
		"el" => "MViGreekj",
		"en" => "piEnglishj",
		"eo" => "GXygiEsperantoj",
		"es" => "XyCiSpanishj",
		"et" => "GXgjAiEstonianj",
		"eu" => "oXNiBasquej",
		"fa" => "yViFarsij",
		"fi" => "tBhiFinnishj",
		"fj" => "tBW[iFijij",
		"fo" => "tF[iFaeroesej",
		"fr" => "tXiFrenchj",
		"fy" => "tWAiFrisianj",
		"ga" => "AChiIrishj",
		"gd" => "XRbghEQ[iGaelic [Scottish]j",
		"gl" => "KVAiGalicianj",
		"gn" => "OjiGuaranij",
		"gu" => "OW[giGujaratij",
		"gv" => "}Q[iGaelic [Manx]j",
		"ha" => "nETiHausaj",
		"he" => "(iw) wuCiHebrewj",
		"hi" => "qfB[iHindij",
		"hr" => "NA`AiCroatianj",
		"hu" => "nK[iHungarianj",
		"hy" => "AjAiArmenianj",
		"ia" => "C^[KiInterlinguaj",
		"id" => "(in) ChlVAiIndonesianj",
		"ie" => "C^[OiInterlinguej",
		"ik" => "CksAiInupiakj",
		"is" => "ACXhiIcelandicj",
		"it" => "C^AiItalianj",
		"iu" => "CkNeBgbgiInuktitutj",
		"ja" => "{iJapanesej",
		"jv" => "WiJavanesej",
		"ka" => "OWAiGeorgianj",
		"kk" => "JUtiKazakhj",
		"kl" => "O[hiGreenlandicj",
		"km" => "J{WAiCambodianj",
		"kn" => "Ji_iKannadaj",
		"ko" => "؍iKoreanj",
		"ks" => "JV~[iKashmirij",
		"ku" => "NhiKurdishj",
		"ky" => "LMXiKirghizj",
		"la" => "eiLatinj",
		"li" => "uK[iLimburgishj",
		"ln" => "KiLingalaj",
		"lo" => "IXiLaotianj",
		"lt" => "gAjAiLithuanianj",
		"lv" => "grAiLatvianj",
		"mg" => "}_KXJiMalagasyj",
		"mi" => "}IiMaorij",
		"mk" => "}PhjAiMacedonianj",
		"ml" => "}[iMalayalamj",
		"mn" => "SiMongolianj",
		"mo" => "_rAiMoldavianj",
		"mr" => "}[eB[iMarathij",
		"ms" => "}[iMalayj",
		"mt" => "}^iMaltesej",
		"my" => "r}iBurmesej",
		"na" => "iEiNauruj",
		"ne" => "lp[iNepalij",
		"nl" => "I_iDutchj",
		"no" => "mEF[iNorwegianj",
		"oc" => "IL^iOccitanj",
		"om" => "IiOromoj",
		"or" => "I[AiOriyaj",
		"pa" => "pWuiPunjabij",
		"pl" => "|[hiPolishj",
		"ps" => "pVgiPashtoj",
		"pt" => "|gKiPortuguesej",
		"qu" => "P`AiQuechuaj",
		"rm" => "g=}iRhaeto-Romancej",
		"rn" => "LfBiKirundij",
		"ro" => "[}jAiRomanianj",
		"ru" => "VAiRussianj",
		"rw" => "Lj[_iKinyarwandaj",
		"sa" => "TXNbgiSanskritj",
		"sd" => "VfB[iSindhij",
		"sg" => "TOiSangroj",
		"sh" => "Z{=NA`AiSerbo-Croatianj",
		"si" => "VniSinhalesej",
		"sk" => "XoLAiSlovakj",
		"sl" => "XxjAiSlovenianj",
		"sm" => "TAiSamoanj",
		"sn" => "ViiShonaj",
		"so" => "\}iSomalij",
		"sq" => "AojAiAlbanianj",
		"sr" => "ZrAiSerbiaj",
		"ss" => "VXeBiSiswatij",
		"st" => "Z\giSesothoj",
		"su" => "X_iSundanesej",
		"sv" => "XEF[fiSwedishj",
		"sw" => "XqiSwahilij",
		"ta" => "^~[iTamilj",
		"te" => "eOiTeluguj",
		"tg" => "^WNiTajikj",
		"th" => "^CiThaij",
		"ti" => "`OjiTigrinyaj",
		"tk" => "gNiTurkmenj",
		"tl" => "^KOiTagalogj",
		"tn" => "ZciiSetswanaj",
		"to" => "gKiTongaj",
		"tr" => "gRiTurkishj",
		"ts" => "cHKiTsongaj",
		"tt" => "^^[iTatarj",
		"tw" => "gEBiTwij",
		"ug" => "ECOiUighurj",
		"uk" => "ENCiiUkrainianj",
		"ur" => "EhD[iUrduj",
		"uz" => "EYxNiUzbekj",
		"vi" => "xgiiVietnamesej",
		"vo" => "{sNiVolapukj",
		"wo" => "EHtiWolofj",
		"xh" => "RTiXhosaj",
		"yi" => "(ji) CfBbViYiddishj",
		"yo" => "oiYorubaj",
		"zh" => "iChinesej",
		"zu" => "Y[[iZuluj",
	);
	return $code_list[$code];
}
?>